# TP 18 : Dictionnaires
# BCPST1B 2023-2024
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

#%% section II.1

d = {"sexe": "2", "prenom": "EMMA", "annee": "2004", "nombre": "6634"}
for k in d.keys():
    print(k)

#%% section II.2

d = {"sexe": "2", "prenom": "EMMA", "annee": "2004", "nombre": "6634"}
for v in d.values():
    print(v)

#%% section II.3

d = {"sexe": "2", "prenom": "EMMA", "annee": "2004", "nombre": "6634"}
for (k, v) in d.items():
    print("clé :", k, "valeur :", v)

#%% exercice 1.1

def facture(d):
    S = 0
    for v in d.values():
        S = S + v
    return S

courses = {"pain": 1.20, "camembert": 3.0, "salade": 1.5, "savon": 3.5}
print(facture(courses))

#%% exercice 1.2

def est_trop_luxueux(d):
    for v in d.values():
        if v >= 5:
            return True
    return False

courses1 = {"pain": 1.20, "camembert": 3.0, "salade": 1.5, "savon": 3.5}
print(est_trop_luxueux(courses1))
courses2 = {"pain": 1.20, "camembert": 3.0, "champagne": 15, "salade": 1.5, "savon": 3.5}
print(est_trop_luxueux(courses2))

#%% exercice 2.1

def nombre_ingredients(d):
    N = 0
    for k in d.keys():
        N = N + 1
    return N

crepes = {"farine": 250, "oeufs": 4, "lait": 300, "beurre": 50, "sucre": 30}
print(nombre_ingredients(crepes))

#%% exercice 2.2

def est_sans_noix(d):
    for k in d.keys():
        if k == "noix":
            if d[k] > 0:
                return False
    return True

crepes = {"farine": 250, "oeufs": 4, "lait": 300, "beurre": 50, "sucre": 30}
print(est_sans_noix(crepes))
tarte_aux_noix = {"farine": 250, "oeufs": 4, "sucre": 100, "noix": 200}
print(est_sans_noix(tarte_aux_noix))
pain = {"farine": 250, "sel": 10, "eau": 130, "noix": 0, "levure": 5}
print(est_sans_noix(pain))

#%% exercice 2.3

def est_sain(d):
    for k in d.keys():
        if k == "sucre":
            if d[k] > 50:
                return False
    return True

crepes = {"farine": 250, "oeufs": 4, "lait": 300, "beurre": 50, "sucre": 30}
print(est_sain(crepes))
tarte_citron = {"pate": 300, "citron": 500, "sucre": 200, "oeuf": 4}
print(est_sain(tarte_citron))
kebab = {"pain": 200, "viande": 150, "frites": 250, "salade": 30}
print(est_sain(kebab))

#%% exercice 3

def oseille(d):
    S = 0
    for (k, v) in d.items():
        S = S + k * v
    return S

d = {1: 4, 2: 7, 10: 1}
print(oseille(d))

#%% exercice 4.1

chiffres = {"zéro": 0, "un": 1, "deux": 2, "trois": 3, "quatre": 4, "cinq": 5, "six": 6, "sept": 7, "huit": 8, "neuf": 9}

def traduit(L):
    M = []
    for c in L:
        x = chiffres[c]
        M.append(x)
    return M

print(traduit(["deux", "huit", "trois"]))

#%% exercice 4.2

def nombre(L):
    N = 0
    for c in L:
        x = chiffres[c]
        N = 10 * N + x
    return N

print(nombre(["deux", "huit", "trois"]))

#%% exercice 4.3

def nombre(s):
    N = 0
    L = s.split()
    for c in L:
        x = chiffres[c]
        N = 10 * N + x
    return N

print(nombre("deux huit trois"))

#%% exercice 5.1

def compte_lettres(s):
    d = {}
    for x in s:
        if x in d:
            d[x] = d[x] + 1
        else:
            d[x] = 1
    return d

print(compte_lettres("VERSAILLES"))
print(compte_lettres("ANANAS"))
print(compte_lettres("Ça marche même avec TOUS les caractères !!!"))

#%% exercice 5.2

def factoriel(n):
    if n == 0:
        return 1
    else:
        return n * factoriel(n-1)

def nombre_anagrammes(s):
    d = compte_lettres(s)
    numerateur = factoriel(len(s))
    denominateur = 1
    for v in d.values():
        denominateur = denominateur * factoriel(v)
    return numerateur // denominateur

print(nombre_anagrammes("BCPST"))
print(nombre_anagrammes("PREPA"))

#%% exercice 6

def identité(n):
    # très court en compréhension !
    return {(i, i): 1 for i in range(n)}

def somme(A, B):
    # matrice nulle
    S = {}
    # copie de A dedans
    for (i, j) in A.keys():
        S[(i, j)] = A[(i, j)]
    # somme B dedans
    for (i, j) in B.keys():
        if (i, j) in S:
            S[(i, j)] = S[(i, j)] + B[(i, j)]
        else:
            S[(i, j)] = B[(i, j)]
    return B

def produit(A, B):
    P = {}
    for (i, j) in A.keys():
        for (k, l) in B.keys():
            if j == k:
                # le produit va se sommer dans P[i, l]
                if (i, l) in P:
                    P[(i, l)] = P[(i, l)] + A[i, j] * B[j, l]
                else:
                    P[(i, l)] = A[i, j] * B[j, l]
    return P

def est_triangulaire_supérieure(A):
    for (i, j) in A.keys():
        if i > j:
            if A[(i, j)] != 0:
                return False
    return True
